"""This module is part of the PygLibsX library.
It is licensed under an open-source, make-shift license by Matthew Roe.
That will change when it is more complete and I know what I want ot do with it."""

import os

import core
from core import *

import mesh
import obj_loader

def main():
    core.init()
    cam = core.Camera()
    L1 = core.Light((0, 0, -15),
                    (1,1,1,1),
                    (1,1,1,1),
                    (1,1,1,1))

    upper_leg = mesh.Bone((0, 1, 0), (0, 0, 0))
    upper_leg_mesh = mesh.MeshPart(obj_loader.OBJ(os.path.join("data", "head.obj")),
                                   upper_leg)
    lower_leg = mesh.Bone((0, 1, 0), (0, 0, 0))
    lower_leg_mesh = mesh.MeshPart(obj_loader.OBJ(os.path.join("data", "head.obj")),
                                   lower_leg)
    upper_leg.attach(lower_leg)

    clock = pygame.time.Clock()

    while 1:
        clock.tick(50)
        for event in pygame.event.get():
            if event.type == QUIT:
                pygame.quit()
                return None

        lower_leg.shift(0, 0, 1)
        core.clear_screen()
        cam.update()

        upper_leg_mesh.render()
        lower_leg_mesh.render()

        pygame.display.flip()

main()
