# Classes for all of the buildings

import math3d

class Building:
    def __init__(self, mesh, position, weight=0, velocity=0):
        mesh.make_cgeom() # create bounding box
        self.mesh = mesh
        self.position = position
        self.weight = weight
        self.velocity = velocity
        self.picked = False
        self.cleanup = False
        self.mesh.collision_geom.pos = math3d.Vector(self.position[0], self.position[2], self.position[1]+3.3)
        geom = self.mesh.collision_geom

    def think(self):
        if self.position[1] < -100:
            self.cleanup = True

    def render(self):
        if self.picked:
            self.mesh.render(self.position, (0,0,0), (1,0,0)) # buildings don't rotate for now
        else:
            self.mesh.render(self.position, (0,0,0)) # buildings don't rotate for now

    def check_collision(self, other):
        return self.mesh.collision_geom.check_collision(other.mesh.collision_geom)

    def move(self, x, y, z):
        self.mesh.collision_geom.pos = math3d.Vector(self.position[0], self.position[2], self.position[1]+3.3)
        self.position = (self.position[0] + x, \
                         self.position[1] + y, \
                         self.position[2] + z  )

class MissileSilo(Building):
    def __init__(self, position):
        self.missile_cost = 100
        self.build_time = 10  # seconds
        self.is_building = False
        self.armed = False

    def think(self):
        return

## GUI checks whether this can be called
    def buildMissile(self, player):
        player.gas -= self.missile_cost
        self.is_building = True

