import os
from globals import *

import core
from core import *

import mesh
import obj_loader
import math3d

from buildings import *
from terrain import *
from missile import *

#objects = list()
#terrain = None
picked_tile = None
#missile = None
#missile2 = None

main_cam = core.Camera()

def setupObjects():
    global objects, terrain, missile, missile2

    modeldir = 'data'
    terrain = Terrain(obj_loader.OBJ(os.path.join(modeldir, "tile.obj"), True), (0,-5,0))
    #missile2 = Missile(obj_loader.OBJ(os.path.join(modeldir, "missile.obj"), True), (43,3,15), (3,3,15))
    #missile = Missile(obj_loader.OBJ(os.path.join(modeldir, "missile.obj"), True), (3,3,15), missile2.position)

    terrain.setupTurrets()

def setupWorld():
    global main_cam

    main_cam = core.Camera()
    main_cam.move((-10,-15,-30))
    main_cam.rotate((45, 0, 0))
    light = core.Light((0, 0, -10), (1,1,1,1),(1,1,1,1),(1,1,1,1))

def render_pick_tile():
    return

def pick_object():
    core.clear_screen()

    mx, my = pygame.mouse.get_pos()
    my = 480 - my
    cur_color = 1
    last_color = glReadPixelsf(mx, my, 1, 1, GL_RGB)
    picked = None

    for i in xrange(len(objects)): # TODO: change to just buildings
        glColor3f(cur_color, 0, 0)
        objects[i].render()

        result = glReadPixelsf(mx, my, 1, 1, GL_RGB)
        if last_color != result:
            picked = i
            last_color = result
            if cur_color == 0:
                cur_color = 1
            else:
                cur_color -= 0.01

    core.clear_screen()

    if( picked ):
        glColor3f(1,1,1)
        return picked

    # didn't select a building, try to pick tiles now
    cur_color = 1
    last_color = glReadPixelsf(mx, my, 1, 1, GL_RGB)

    for i in range(3 * (4 / 2)): #  hardcoded for now..
        for j in range(3 * (4 / 2)):
            glColor3f(cur_color, 0, 0)
            terrain.renderTile(i, j, (cur_color, 0, 0))

            result = glReadPixelsf(mx, my, 1, 1, GL_RGB)
            if last_color != result:
                picked = (i, j)
                last_color = result
                if cur_color == 0:
                    cur_color = 1
                else:
                    cur_color -= 0.01

    core.clear_screen()
    glColor3f(1,1,1)
    return picked

def checkEvents():
    global main_cam, terrain, picked_tile, missile2

    for event in pygame.event.get():
        if event.type == QUIT or event.type == KEYDOWN and event.key == K_ESCAPE:
            print 'You lasted', pygame.time.get_ticks()/1000, 'seconds!'
            pygame.quit()
            sys.exit()
        if event.type == KEYDOWN:
            if event.key == K_UP:
                main_cam.rotate((5,0,0))
            if event.key == K_DOWN:
                main_cam.rotate((-5,0,0))
            if event.key == K_LEFT:
                main_cam.rotate((0,-5,0))
            if event.key == K_RIGHT:
                main_cam.rotate((0,5,0))
            if event.key == K_w:
                main_cam.move((0,-5,0))
            if event.key == K_s:
                main_cam.move((0,5,0))
            if event.key == K_a:
                main_cam.move((5,0,0))
            if event.key == K_d:
                main_cam.move((-5,0,0))
            if event.key == K_z:
                main_cam.move((0,0,-5))
            if event.key == K_x:
                main_cam.move((0,0,5))
            if event.key == K_p:
                print 'pos', main_cam.position, 'rot', main_cam.angle
            if event.key == K_1:
                terrain.takeDamage((0,0))
            if event.key == K_h:
                missile2.think()
        if event.type == MOUSEBUTTONUP and event.button == 1:
            picked = pick_object() # see what we clicked on
            if picked != None:
                print 'Picked!', picked
                if isinstance(picked, tuple):
                    picked_tile = picked
                else:
                    objects[picked].cleanup = True 

def renderWorld():
    global picked_tile, objects, buildings

    terrain.think()
    terrain.render()
    #terrain.renderGrid() # for testing purposes
    for i in objects:
        i.think()
        i.render()

    for i in buildings:
        if not terrain.check_collision(i):
            i.move(0, -GRAVITY, 0)
        i.think()
        i.render()
        
    if( picked_tile ):
        terrain.renderTile(*picked_tile)

    cleanUp()

def cleanUp():
    global objects, buildings
    cleanup = []

    for i in objects:
        if i.cleanup == True:
            cleanup.append(i)

    for i in cleanup:
        objects.remove(i)

    cleanup = []
    for i in buildings:
        if i.cleanup:
            cleanup.append(i)

    for i in cleanup:
        buildings.remove(i)


def main():
    core.init()
    pygame.display.set_caption("Towers of Skye")
    setupWorld()

    clock = pygame.time.Clock()
    setupObjects()

    while True:
        clock.tick(30)

        core.clear_screen()
        main_cam.update()

        checkEvents()
        renderWorld()
        pygame.display.flip()

main()
