import math3d
import math

from core import *

#from terrain import *

class Missile:
    def __init__(self, mesh, origin, target):
        self.mesh = mesh
        self.origin = origin
        self.target = target
        self.position = origin
        self.flightpath = None
        self.pathnode = 0
        self.velocity = 5
        self.damage = 10
        self.hitpoints = 20
        self.cleanup = False

        self._steps = 36 * 3

        self.arcToTarget()

    def think(self):
#        global terrain

        self.position = self.flightpath[self.pathnode]
        self.pathnode += 1
        if self.pathnode >= len(self.flightpath):
            self.pathnode = 0
        self.arcToTarget()
        if self.pathnode == int(self._steps / 2 + 7):# + self._steps * 1.0/3):
        #if self.pathnode == int(self._steps / 3.0/7): 
            #print 'Hit target!', self.pathnode
            self.target.takeDamage()
            self.cleanup = True

    def render(self):
        self.mesh.render(self.position, (0,90,0))

        if False: # for debugging
            glBegin(GL_LINE_STRIP)
            glColor3f(1,0,0)
            for vec in self.flightpath:
                glVertex3f(*vec)
            glEnd()

# x  X coordinate
# y  Y coordinate
# a  Semimajor axis
# b  Semiminor axis
# angle  Angle of the ellipse
    def arcToTarget(self):#(x, y, a, b, angle, steps) 
        steps = 30
        orig = math3d.Vector(*self.origin)
        trgt = math3d.Vector(*self.target.position)
        #center = vec.sub(trgt)
        distance = orig.get_distance(trgt)
        max_height = 30

        # get midpoints
        x = (orig.x + trgt.x) / 2
        y = (orig.y + trgt.y) / 2
        #print 'x', trgt.x, 'y', trgt.y, 'z', trgt.z
        Z = orig.z
        #print x, y
        a = distance / 2
        b = 20.0
        angle = 0

        steps = self._steps # TODO: fixme with passed param
        points = list()
         
        beta = -angle / 180.0 * math.pi
        sinbeta = math.sin(beta)
        cosbeta = math.cos(beta)
     
        for i in xrange(0, 360, 360 / steps):
            alpha = i / 180.0 * math.pi
            sinalpha = math.sin(alpha)
            cosalpha = math.cos(alpha)

            X = x + (a * cosalpha * cosbeta - b * sinalpha * sinbeta)
            Y = y + (a * cosalpha * sinbeta + b * sinalpha * cosbeta)

            points.append((X, Y, Z))
 
        self.flightpath = points
#        size = 2
#        glBegin(GL_QUADS)
#        glColor3f(0,0,1)
#        glVertex3f(points[0].x+size, points[0].y+size, points[0].z)
#        glVertex3f(points[0].x-size, points[0].y+size, points[0].z)
#        glVertex3f(points[0].x-size, points[0].y-size, points[0].z)
#        glVertex3f(points[0].x+size, points[0].y-size, points[0].z)
#        glEnd()
#        size = 2
#        glBegin(GL_QUADS)
#        glColor3f(0,1,0)
#        glVertex3f(points[1].x+size, points[1].y+size, points[1].z)
#        glVertex3f(points[1].x-size, points[1].y+size, points[1].z)
#        glVertex3f(points[1].x-size, points[1].y-size, points[1].z)
#        glVertex3f(points[1].x+size, points[1].y-size, points[1].z)
#        glEnd()
